//#line 2 "/opt/ros/boxturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the stereo_image_proc package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __stereo_image_proc__STEREOIMAGEPROCCONFIG_H__
#define __stereo_image_proc__STEREOIMAGEPROCCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace stereo_image_proc
{
  class StereoImageProcConfigStatics;
  
  class StereoImageProcConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(StereoImageProcConfig &config, const StereoImageProcConfig &max, const StereoImageProcConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const StereoImageProcConfig &config1, const StereoImageProcConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, StereoImageProcConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const StereoImageProcConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, StereoImageProcConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const StereoImageProcConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T StereoImageProcConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (StereoImageProcConfig::* field);

      virtual void clamp(StereoImageProcConfig &config, const StereoImageProcConfig &max, const StereoImageProcConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const StereoImageProcConfig &config1, const StereoImageProcConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, StereoImageProcConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const StereoImageProcConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, StereoImageProcConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const StereoImageProcConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 15 "../cfg/StereoImageProc.cfg"
      int prefilter_size;
//#line 16 "../cfg/StereoImageProc.cfg"
      int prefilter_cap;
//#line 19 "../cfg/StereoImageProc.cfg"
      int correlation_window_size;
//#line 20 "../cfg/StereoImageProc.cfg"
      int min_disparity;
//#line 21 "../cfg/StereoImageProc.cfg"
      int disparity_range;
//#line 26 "../cfg/StereoImageProc.cfg"
      int uniqueness_ratio;
//#line 27 "../cfg/StereoImageProc.cfg"
      int texture_threshold;
//#line 28 "../cfg/StereoImageProc.cfg"
      int speckle_size;
//#line 29 "../cfg/StereoImageProc.cfg"
      int speckle_range;
//#line 138 "/opt/ros/boxturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("StereoImageProcConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const StereoImageProcConfig &__max__ = __getMax__();
      const StereoImageProcConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const StereoImageProcConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const StereoImageProcConfig &__getDefault__();
    static const StereoImageProcConfig &__getMax__();
    static const StereoImageProcConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const StereoImageProcConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void StereoImageProcConfig::ParamDescription<std::string>::clamp(StereoImageProcConfig &config, const StereoImageProcConfig &max, const StereoImageProcConfig &min) const
  {
    return;
  }

  class StereoImageProcConfigStatics
  {
    friend class StereoImageProcConfig;
    
    StereoImageProcConfigStatics()
    {
//#line 15 "../cfg/StereoImageProc.cfg"
      __min__.prefilter_size = 5;
//#line 15 "../cfg/StereoImageProc.cfg"
      __max__.prefilter_size = 255;
//#line 15 "../cfg/StereoImageProc.cfg"
      __default__.prefilter_size = 9;
//#line 15 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("prefilter_size", "int", 0, "Normalization window size, pixels", "", &StereoImageProcConfig::prefilter_size)));
//#line 16 "../cfg/StereoImageProc.cfg"
      __min__.prefilter_cap = 1;
//#line 16 "../cfg/StereoImageProc.cfg"
      __max__.prefilter_cap = 63;
//#line 16 "../cfg/StereoImageProc.cfg"
      __default__.prefilter_cap = 31;
//#line 16 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("prefilter_cap", "int", 0, "Bound on normalized pixel values", "", &StereoImageProcConfig::prefilter_cap)));
//#line 19 "../cfg/StereoImageProc.cfg"
      __min__.correlation_window_size = 5;
//#line 19 "../cfg/StereoImageProc.cfg"
      __max__.correlation_window_size = 255;
//#line 19 "../cfg/StereoImageProc.cfg"
      __default__.correlation_window_size = 15;
//#line 19 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("correlation_window_size", "int", 0, "SAD correlation window width, pixels", "", &StereoImageProcConfig::correlation_window_size)));
//#line 20 "../cfg/StereoImageProc.cfg"
      __min__.min_disparity = -128;
//#line 20 "../cfg/StereoImageProc.cfg"
      __max__.min_disparity = 128;
//#line 20 "../cfg/StereoImageProc.cfg"
      __default__.min_disparity = 0;
//#line 20 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("min_disparity", "int", 0, "Disparity to begin search at, pixels (may be negative)", "", &StereoImageProcConfig::min_disparity)));
//#line 21 "../cfg/StereoImageProc.cfg"
      __min__.disparity_range = 32;
//#line 21 "../cfg/StereoImageProc.cfg"
      __max__.disparity_range = 128;
//#line 21 "../cfg/StereoImageProc.cfg"
      __default__.disparity_range = 64;
//#line 21 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("disparity_range", "int", 0, "Number of disparities to search, pixels", "", &StereoImageProcConfig::disparity_range)));
//#line 26 "../cfg/StereoImageProc.cfg"
      __min__.uniqueness_ratio = 0;
//#line 26 "../cfg/StereoImageProc.cfg"
      __max__.uniqueness_ratio = 100;
//#line 26 "../cfg/StereoImageProc.cfg"
      __default__.uniqueness_ratio = 15;
//#line 26 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("uniqueness_ratio", "int", 0, "Filter out if best match does not sufficiently exceed the next-best match", "", &StereoImageProcConfig::uniqueness_ratio)));
//#line 27 "../cfg/StereoImageProc.cfg"
      __min__.texture_threshold = 0;
//#line 27 "../cfg/StereoImageProc.cfg"
      __max__.texture_threshold = 100;
//#line 27 "../cfg/StereoImageProc.cfg"
      __default__.texture_threshold = 10;
//#line 27 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("texture_threshold", "int", 0, "Filter out if SAD window response does not exceed texture threshold", "", &StereoImageProcConfig::texture_threshold)));
//#line 28 "../cfg/StereoImageProc.cfg"
      __min__.speckle_size = 0;
//#line 28 "../cfg/StereoImageProc.cfg"
      __max__.speckle_size = 1000;
//#line 28 "../cfg/StereoImageProc.cfg"
      __default__.speckle_size = 100;
//#line 28 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("speckle_size", "int", 0, "Reject regions smaller than this size, pixels", "", &StereoImageProcConfig::speckle_size)));
//#line 29 "../cfg/StereoImageProc.cfg"
      __min__.speckle_range = 0;
//#line 29 "../cfg/StereoImageProc.cfg"
      __max__.speckle_range = 31;
//#line 29 "../cfg/StereoImageProc.cfg"
      __default__.speckle_range = 4;
//#line 29 "../cfg/StereoImageProc.cfg"
      __param_descriptions__.push_back(StereoImageProcConfig::AbstractParamDescriptionConstPtr(new StereoImageProcConfig::ParamDescription<int>("speckle_range", "int", 0, "Max allowed difference between detected disparities", "", &StereoImageProcConfig::speckle_range)));
//#line 239 "/opt/ros/boxturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<StereoImageProcConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<StereoImageProcConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    StereoImageProcConfig __max__;
    StereoImageProcConfig __min__;
    StereoImageProcConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const StereoImageProcConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static StereoImageProcConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &StereoImageProcConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const StereoImageProcConfig &StereoImageProcConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const StereoImageProcConfig &StereoImageProcConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const StereoImageProcConfig &StereoImageProcConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<StereoImageProcConfig::AbstractParamDescriptionConstPtr> &StereoImageProcConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const StereoImageProcConfigStatics *StereoImageProcConfig::__get_statics__()
  {
    const static StereoImageProcConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = StereoImageProcConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __STEREOIMAGEPROCRECONFIGURATOR_H__
