## *********************************************************
## 
## File autogenerated for the stereo_image_proc package 
## by the dynamic_reconfigure package.
## Please do not edit.
## 
## ********************************************************/

##**********************************************************
## Software License Agreement (BSD License)
##
##  Copyright (c) 2008, Willow Garage, Inc.
##  All rights reserved.
##
##  Redistribution and use in source and binary forms, with or without
##  modification, are permitted provided that the following conditions
##  are met:
##
##   * Redistributions of source code must retain the above copyright
##     notice, this list of conditions and the following disclaimer.
##   * Redistributions in binary form must reproduce the above
##     copyright notice, this list of conditions and the following
##     disclaimer in the documentation and/or other materials provided
##     with the distribution.
##   * Neither the name of the Willow Garage nor the names of its
##     contributors may be used to endorse or promote products derived
##     from this software without specific prior written permission.
##
##  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
##  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
##  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
##  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
##  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
##  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
##  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
##  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
##  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
##  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
##  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
##  POSSIBILITY OF SUCH DAMAGE.
##**********************************************************/

config_description = [{'srcline': 15, 'description': 'Normalization window size, pixels', 'max': 255, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'prefilter_size', 'edit_method': '', 'default': 9, 'level': 0, 'min': 5, 'type': 'int'}, {'srcline': 16, 'description': 'Bound on normalized pixel values', 'max': 63, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'prefilter_cap', 'edit_method': '', 'default': 31, 'level': 0, 'min': 1, 'type': 'int'}, {'srcline': 19, 'description': 'SAD correlation window width, pixels', 'max': 255, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'correlation_window_size', 'edit_method': '', 'default': 15, 'level': 0, 'min': 5, 'type': 'int'}, {'srcline': 20, 'description': 'Disparity to begin search at, pixels (may be negative)', 'max': 128, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'min_disparity', 'edit_method': '', 'default': 0, 'level': 0, 'min': -128, 'type': 'int'}, {'srcline': 21, 'description': 'Number of disparities to search, pixels', 'max': 128, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'disparity_range', 'edit_method': '', 'default': 64, 'level': 0, 'min': 32, 'type': 'int'}, {'srcline': 26, 'description': 'Filter out if best match does not sufficiently exceed the next-best match', 'max': 100, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'uniqueness_ratio', 'edit_method': '', 'default': 15, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 27, 'description': 'Filter out if SAD window response does not exceed texture threshold', 'max': 100, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'texture_threshold', 'edit_method': '', 'default': 10, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 28, 'description': 'Reject regions smaller than this size, pixels', 'max': 1000, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'speckle_size', 'edit_method': '', 'default': 100, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 29, 'description': 'Max allowed difference between detected disparities', 'max': 31, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/StereoImageProc.cfg', 'name': 'speckle_range', 'edit_method': '', 'default': 4, 'level': 0, 'min': 0, 'type': 'int'}]

min = {}
max = {}
defaults = {}
level = {}
type = {}
all_level = 0

for param in config_description:
    min[param['name']] = param['min']
    max[param['name']] = param['max']
    defaults[param['name']] = param['default']
    level[param['name']] = param['level']
    type[param['name']] = param['type']
    all_level = all_level | param['level']

